<?php
error_reporting(E_ALL);
assert_options(ASSERT_WARNING, 0);

$path_lib_main = $path_root."lib/octoploid/";
$path_lib_app = $path_app."lib/";

$path_lib_main_php = $path_lib_main."php/";
$path_lib_app_php = $path_lib_app."php/";

include_once dirname(__FILE__).'/error_handler_include.php';

function generate_error($message) {
  trigger_error($message, E_USER_ERROR);
}

function generate_warning($message) {
  trigger_error($message, E_USER_WARNING);
}

function generate_notice($message) {
  trigger_error($message, E_USER_NOTICE);
}

function relative_redirect($relative_url) {
  header('Location: '.make_absolute_url($relative_url));
}

function path_relative_to_here($path) {
  $from = realpath(dirname($_SERVER["SCRIPT_FILENAME"]));
  $to = realpath(dirname(__FILE__)."/".$path);
  return relative_path($to,$from);
}

function relative_path($targetfile, $basedir = '.') {
   $basedir    = realpath ($basedir);
   $targetfile = realpath ($targetfile);

   // on windows, check that both paths are on the same drive
   if (substr ($basedir, 0, 1) != substr ($targetfile, 0, 1)) {
       return false;
   }

   // split each path into its directories
   $base_parts  = split ('\/', str_replace ('\\', '/', $basedir));
   $target_parts = split ('\/', str_replace ('\\', '/', $targetfile));

   // ensure that there are no empty elements at the end (c:\ would cause it)
   for ($i = count($base_parts) - 1; $i >= 0; $i--) {
       if ($base_parts[$i] == '') {
           unset ($base_parts[$i]);
       } else {
           break;
       }
   }
   for ($i = count($target_parts) - 1; $i >= 0; $i--) {
       if ($target_parts[$i] == '') {
           unset ($target_parts[$i]);
       } else {
           break;
       }
   }

   // get rid of the common directories at the beginning of the paths
   $common_count = 0;
   for ($i = 0; $i < count($base_parts); $i++) {
       if ($target_parts[$i] == $base_parts[$i]) {
           $common_count++;
       } else {
           break;
       }
   }
   for ($i = 0; $i < $common_count; $i++) {
       unset ($base_parts[$i]);
       unset ($target_parts[$i]);
   }

   // build the resulting string
   $cnt = count($base_parts);
   //if ($cnt < 1) {
    //$cnt = 0;
   //}

   return str_repeat ('../', $cnt).implode('/', $target_parts);
}
?>
