<?php

// This class encapsulates the PEAR database classes.
//
// It allows the ability to extend their functionality
// and offer a customised interface to them.
//
// It also should facilitate switching out PEAR -
// and employing a different database connection technology -
// at a later date - should that prove desirable.

class DatabaseConnection {
  var $connection;

  function DatabaseConnection($data_source_name, $error = false) {
    //echo 'ata_source_name:'.$data_source_name.'<br>';
    //print_r(DB::connect($data_source_name)).'<br>';

    $connection = DB::connect($data_source_name);

    $this -> connection = $connection;

    if (!$error && ($this -> isError())) {
      generate_error("Error during database connection:".$this -> getMessage().' - DSN:['.$data_source_name.']');
    }
  }

  function query($query, $error = false) {
    $result = new DatabaseResult($this -> connection -> query($query));

    if (!$error && ($result -> isError())) {
      generate_error("Error during execution of database query:".$result -> getMessage().' - query:['.$query.']');
    }

    return $result;
  }

  function isError() {
    return DB::isError($this -> connection);
  }

  function getMessage() {
    return $this -> connection -> getMessage();
  }

  function disconnect() {
    return $this -> connection -> disconnect();
  }

  function listDatabases() {
    return $this -> connection -> getListOf('databases');
  }

  function listTables() {
    return $this -> connection -> getListOf('tables');
  }

  function getColumns($table) {
    return $this -> connection -> tableInfo($table, null);
  }
}

//misc...

//ini_set('include_path', '~/pear/lib'.PATH_SEPARATOR.ini_get('include_path'));

//getListOf( string $type)

// old way...

//function db_num_rows($result) {
//  if ($result) {
//    return $result->numRows($result);
//  }
//}

//function db_query($connection, $query) {
//  return $connection->query($query);;
//}
//
//function db_query_quick($connection, $query) {
//  $result = $connection->query($query);
//
//  if (db_error($result)) {
//    die ("Error during execution of database query:".db_get_message($result).' - query:['.$query.']');
//  }
//
//  return $result;
//}
//
//function db_get_next_row($result) {
//  return $result->fetchRow();
//}
//
//function db_get_next_row_array($result) {
//  if ($result) {
//    return $result->fetchRow(DB_FETCHMODE_ASSOC);
//  }
//}
//
//function db_connect($data_source_name) {
//  return DB::connect($data_source_name);
//}
//
//function db_connect_quick($data_source_name) {
//  $connection = DB::connect($data_source_name);
//
//  if (db_error($connection)) {
//    die ("Error during execution of database query:".db_get_message($connection).' - DSN:['.$data_source_name.']');
//  }
//
//  return $connection;
//}

//function db_disconnect($connection) {
//  $connection->disconnect();
//}
//
//function db_free_result($result) {
//  $result->free();
//}
//
//function db_error($type) {
//  return DB::isError($type);
//}
//
//function db_get_message($type) {
//  return $type->getMessage();
//}

?>
