<?php

define('ERROR_HANDLER_ROOT', dirname(__FILE__));

class ErrorHandler {

  function ErrorHandler() {
    ini_set('docref_root', null);
    ini_set('docref_ext', null);
  }

  function raiseError($errNo, $errMsg, $file, $line) {
    if (!($errNo & error_reporting())) {
        return;
    }

    while (ob_get_level()) {
        ob_end_clean();
    }

    $errType = array (
      1    => "PHP error",
      2    => "PHP warning",
      4    => "PHP parsing error",
      8    => "PHP notice",
      16   => "PHP core error",
      32   => "PHP core warning",
      64   => "PHP compile error",
      128  => "PHP compile warning",
      256  => "PHP user error",
      512  => "PHP user warning",
      1024 => "PHP user notice"
    );

    $info = array();

    if (($errNo & E_USER_ERROR) && is_array($arr = @unserialize($errMsg))) {
      foreach ($arr as $k => $v) {
        $info[$k] = $v;
      }
    }

    $trace = array();

    if (function_exists('debug_backtrace')) {
      $trace = debug_backtrace();
      array_shift($trace);
    }

    echo '<P>';

    include ERROR_HANDLER_ROOT.'/error_handler.tem.php';
    exit;
  }
}

?>
