<?php

function error_handler_fatal($buffer) {
  if (ereg("(error</b>:)(.+)(<br)", $buffer, $regs)) {
    $err = preg_replace('/<.*?>/','',$regs[2]);

    return $buffer."<HR>Fatal error:".$err.'<HR>'.get_backtrace(false);
  }
  return $buffer;
}

 function get_backtrace($print=true)
 {
     $s = '';
     if (PHPVERSION() >= 4.3) {

         $MAXSTRLEN = 64;

         $s = '<pre align=left>';
         $traceArr = debug_backtrace();
         array_shift($traceArr);
         $tabs = sizeof($traceArr)-1;
         foreach ($traceArr as $arr) {
             for ($i=0; $i < $tabs; $i++) $s .= ' &nbsp; ';
             $tabs -= 1;
             $s .= '<font face="Courier New,Courier">';
             if (isset($arr['class'])) $s .= $arr['class'].'.';
             foreach($arr['args'] as $v) {
                 if (is_null($v)) $args[] = 'null';
                 else if (is_array($v)) $args[] = 'Array['.sizeof($v).']';
                 else if (is_object($v)) $args[] = 'Object:'.get_class($v);
                 else if (is_bool($v)) $args[] = $v ? 'true' : 'false';
                 else {
                     $v = (string) @$v;
                     $str = htmlspecialchars(substr($v,0,$MAXSTRLEN));
                     if (strlen($v) > $MAXSTRLEN) $str .= '...';
                     $args[] = $str;
                 }
             }

             $s .= sprintf("</font><HR><font color=#808080 size=-1> ");
             $s .= "Function:".$arr['function'].'('.implode(', ',$args).')';
             $s .= sprintf("</font><BR>");

             $keys = array_keys($arr);
             //foreach($keys as $key) {
               //$s .= sprintf("%s<BR>", $key);
             //}
             if (isset($arr['line'])) {
               $s .= sprintf("<font color=#808080 size=-1> Line: %4d </font><BR>",$arr['line']);
               $s .= sprintf("<font color=#808080 size=-1> File: <a href=\"file:/%s\">%s</a></font><HR>",$arr['file'],$arr['file']);
             }
             $s .= "\n";
         }
         $s .= '</pre>';
         if ($print) print $s;
     }
     return $s;
 }

function printr($var, $name='$var', $echo=TRUE) {
   $str = highlight_string("<?php\n$name = ".var_export($var, 1).";\n?>\n", 1);
   if ($echo) {
     echo $str;
   } else {
     return $str;
   }
}


?>
