<?php
function parse_web_address($a, $b) {
  $txt = $b;
  if(!strstr($b,'://'))
    $url = 'http://'.$b;
  else
    $url = $b;
  return $a.'<a href="'.$url.'">'.$txt.'</a>';
}

function parse_email($email) {
  return '<a href="mailto:'.$email.'">'.$email.'</a>';
}

function parse_keyword($kw, $keyword) {
  return $kw.':<a href="aol://1722:'.$keyword.'/">'.$keyword.'</a>';
}

function parse_bold($text) {
  return '<strong>'.$text.'</strong>';
}

function parse_italic($text) {
  return ' <em>'.$text.'</em> ';
}

function parse_underline($text) {
  return '<U>'.$text.'</U>';
}

function parse_highlight($text) {
  return '<font color="red">'.$text.'</font>';
}

function make_urls_into_links($text) {
  $reg_exp = '#([^\w=/@\]]|^)((?:www\.[\w-]+\.[\w-]+?\S*?)|(?:[a-z]{3,6}://\S+?))(?=[^a-z0-9/]*?(?:[\s<\][]|(?:&(?:quot|lt|gt);)|$))#ie';
  return preg_replace($reg_exp, 'parse_web_address("$1", "$2")', $text);
}

function make_keywords_into_links($text) {
  $reg_exp = '#(kw|keyword):([A-Z_.0-9-\']+)#ie';
  return stripslashes(preg_replace($reg_exp, 'parse_keyword("$1", "$2")', $text));
}

function make_emails_into_links($text) {
  $reg_exp = '#([A-Z_.-0-9]+@[A-Z_.0-9]+)#ie';
  return preg_replace($reg_exp, 'parse_email("$1")', $text);
}

function make_starred_text_bold($text) {
  $reg_exp = '#\*([A-Z_.-0-9]+)\*#ie';
  return preg_replace($reg_exp, 'parse_bold("$1")', $text);
}

function make_slashed_text_italic($text) {
  $reg_exp = '# \/([A-Z_.-0-9]+)\/ #ie';
  return preg_replace($reg_exp, 'parse_italic("$1")', $text);
}

function make_underscored_text_underlined($text) {
  $reg_exp = '#_([A-Z_.-0-9]+)_#ie';
  return preg_replace($reg_exp, 'parse_underline("$1")', $text);
}

function make_exclaimed_text_highlighted($text) {
  $reg_exp = '#\!([A-Z_.-0-9]+)\!#ie';
  return preg_replace($reg_exp, 'parse_highlight("$1")', $text);
}

//function deal_with_html_entities($text) {
//  $search[0] = '&';
//  $search[1] = '<';
//  $search[2] = '>';
//  $search[3] = '"';
//
//  $replace[0] = '&amp;';
//  $replace[1] = '&lt;';
//  $replace[2] = '&gt;';
//  $replace[3] = '&quot;';
//
//  return nl2br(str_replace($search, $replace, $text));
//}

function safe_text_to_html($text) {
  if (substr($text, 0, 6) == "<HTML>") {
    return substr($text, 6);
  }

  //$text = nl2br(deal_with_html_entities($text));
  $text = nl2br(htmlentities($text));
  $text = make_urls_into_links($text);
  $text = make_emails_into_links($text);
  $text = make_keywords_into_links($text);
  $text = make_starred_text_bold($text);
  $text = make_slashed_text_italic($text);
  $text = make_underscored_text_underlined($text);
  $text = make_exclaimed_text_highlighted($text);

  return $text;
}
?>
