<?php

require_once(path_relative_to_here ("utilities_url.inc.php"));

function check_session_validity($connection,$table_name_sessions,$path_on_error) {
  if (!session_cookie_exists()) {
    header("Location: ".append_argument_string_to_url($path_on_error,"no_session=true"));
    die("Invalid session: - redirect");
    return;
  }

  if (!session_id_exists()) {
    header("Location: ".append_argument_string_to_url($path_on_error,"no_session_id=true"));
    die("Invalid session: - redirect");
    return;
  }

  if (!session_valid($connection,$table_name_sessions)) {
    header("Location: ".append_argument_string_to_url($path_on_error,"no_session_valid=true"));
    die("Invalid session: - redirect");
    return;
  }
}

function session_cookie_exists() {
  session_start_a_session();

  if (!session_session_id_is_set()) {
    return false;
  }

  return true;
}

function session_id_exists() {
  if (!session_session_id_is_set()) {
    return false;
  }

  $sid = session_get_session_id();

  if ($sid == "") {
    return false;
  }

  return true;
}

function session_valid($connection, $table_name_sessions) {
  //session_start_a_session();

  if (!session_session_id_is_set()) {
    return false;
  }

  $sid = session_get_session_id();

  //if ($sid == "") {
    //return false;
  //}

  session_clean_up(100000, $connection, $table_name_sessions);

	$query = "SELECT email FROM ".$table_name_sessions." WHERE sid = '".$sid."'";

  $result = $connection -> query($query);

  $row = $result -> fetchRowAssoc();

  $email = $row['email'];

  if ($email != "") {
	  $query = "UPDATE ".$table_name_sessions." SET last_active = now() WHERE sid = '".$sid."'";

    $result = $connection -> query($query);

    return true;
  }

  return false;
}

function session_get_email($connection, $table_name_sessions) {
  if (!session_session_id_is_set()) {
    return false;
  }

  $sid = session_get_session_id();

  if ($sid == "") {
    return false;
  }

  session_clean_up(100000, $connection, $table_name_sessions);

  $query = "SELECT email FROM ".$table_name_sessions." WHERE sid = '".$sid."'";
  $result = $connection -> query($query);
  $row = $result -> fetchRowAssoc();
  $email = $row['email'];

  return $email;
}

function session_get_name($connection, $table_name_sessions, $table_name_workers) {
  $email = session_get_email($connection, $table_name_sessions);
  $query = "SELECT name FROM ".$table_name_workers." WHERE email = '".$email."'";
  $result = $connection -> query($query);
  $row = $result -> fetchRowAssoc();
  $name = $row['name'];

  return $name;
}

function session_clean_up($lifetime, $connection, $table_name_sessions) {
  $query = 'DELETE FROM '.$table_name_sessions.' WHERE last_active < (now() - '.$lifetime.')';
  $result = $connection -> query($query);
}

function session_logout($connection, $table_name_sessions) {
  session_start_a_session();
  $sid = session_get_session_id();
  $query = "DELETE FROM ".$table_name_sessions." WHERE sid = '".$sid."'";
  $result = $connection -> query($query);
}

function session_generate_session_id() {
  return md5(uniqid(rand(), true));
}

function session_get_session_id() {
  return $_SESSION["sid"];
  //return $_COOKIE["octoploid_session_id"];
  //$session_id = session_generate_session_id();
  //$sid = $_COOKIE["sid"];
  //return $sid;
}

function session_session_id_is_set() {
  return isset($_SESSION["sid"]);
  //return isset($_COOKIE["octoploid_session_id"]);
}

function session_set_session_id($sid) {
  $_SESSION["sid"] = $sid;
  //setcookie ("octoploid_session_id", $sid, time() + 3600, "/");
}

function session_clear_session_id($sid) {
  $_SESSION["sid"] = $sid;
  //setcookie ("octoploid_session_id", "", time() - 60000);
}

function session_start_a_session() {
  session_start();
}
?>
