<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."utilities_get_and_post.inc.php");
require_once ($path_lib_main_php."safe_text_to_html.inc.php");

$script_name = $_SERVER['SCRIPT_NAME'];
$app_name = "Taxonomy Editor";
include_header_top($path_root, $path_app, $app_name);
title_image($path_root);
render_app_title($app_name);

$connection = new DatabaseConnection($data_source_name);

$tree_parent = ensure_string_from_get('parent');
$tree_name = ensure_string_from_get('name');
$layout = tax_get_layout();

$query_string = $_SERVER['QUERY_STRING'];

if ($layout == 'f') {
  $tree_root = $path_root.'lib/tree/';
} else {
  $tree_root = $path_root.'lib/tree_nest/';
}

include_once($tree_root."php/tree_factory.class.php");
$tree_factory = new tree_factory($tree_root);
?>

<script language="JavaScript" type="text/javascript" src="lib/js/taxonomy_editor.js"></script>

<center>
<BR>
<?php

echo '<TABLE><TR><TD valign="center" align="right">';
echo 'View:</TD><TD align="center">';
echo '<a href="index.php?'.$query_string.'&layout=f">Tree</a><BR>';
echo '</TD><TD align="center">';
echo '<a href="index.php?'.$query_string.'&layout=1">V1</a><BR>';
echo '</TD><TD align="center">';
echo '<a href="index.php?'.$query_string.'&layout=2">H1</a><BR>';
echo '</TD><TD align="center">';
echo '<a href="index.php?'.$query_string.'&layout=v">V2</a><BR>';
echo '</TD><TD align="center">';
echo '<a href="index.php?'.$query_string.'&layout=h">H2</a><BR>';
echo '</TD></TR>';
echo '<TR><TD valign="center" align="right">';
echo 'Preview:</TD><TD align="center">';
echo '<a href="preview.php?name='.$tree_name.'&parent='.$tree_parent.'&layout=f"><img border="0" src="graphics/preview.png"></a>';
echo '</TD><TD align="center">';
echo '<a href="preview.php?name='.$tree_name.'&parent='.$tree_parent.'&layout=1"><img border="0" src="graphics/preview.png"></a>';
echo '</TD><TD align="center">';
echo '<a href="preview.php?name='.$tree_name.'&parent='.$tree_parent.'&layout=2"><img border="0" src="graphics/preview.png"></a>';
echo '</TD><TD align="center">';
echo '<a href="preview.php?name='.$tree_name.'&parent='.$tree_parent.'&layout=v"><img border="0" src="graphics/preview.png"></a>';
echo '</TD><TD align="center">';
echo '<a href="preview.php?name='.$tree_name.'&parent='.$tree_parent.'&layout=h"><img border="0" src="graphics/preview.png"></a>';
echo '</TD></TR></TABLE>';
?>

<BR>
</center>

<?php

echo '<form name="form1" method="POST" onSubmit="return verifyAndSubmitForm();">';

$tree = $tree_factory -> web_tree($layout);

$tree -> collapse_beyond_level(99);

if ($layout == 'f') {
  $tree -> collapse_all();
  $tree -> open_as_far_as(2);
  $tree -> expand_all();
}

$table_name = 'tax_'.$tree_name;
$query = 'SELECT parent FROM '.$table_name.' WHERE id="'.$tree_parent.'";';
$result = $connection -> query($query);
$number_of_rows_found = $result -> numRows();

if ($number_of_rows_found > 0) {
  $row = $result -> fetchRowAssoc();
  $parent_of_parent = $row['parent'];
  echo ' - ';
  display_up($parent_of_parent, $tree_name, $layout);
}

$tree_render_from_table = new tree_render_from_table($tree);

$tree_render_from_table -> display_tree($tree_parent, $tree_name, $connection, ($layout != 'f'));

$tree -> node_end();

$tree_factory -> finalise();

?>

<BR>

<center>
<TABLE>
<TR>
<TD align="center">

<input type="hidden" name="parent" value="<?php echo $tree_parent; ?>">
<input type="hidden" name="name" value="<?php echo $tree_name; ?>">
<INPUT type="hidden" name="layout" value="<?php echo $layout; ?>">

<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="All">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="None">
<INPUT style="FONT-SIZE: 16px" type="SUBMIT" name="Operation" onClick="set_up_vars(this);" value="Edit">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="Delete">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="Prune">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="Clone">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="Birth">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="Swap">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="Graft">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="Up">
<INPUT style="FONT-SIZE: 16px" TYPE="SUBMIT" name="Operation" onClick="set_up_vars(this);" VALUE="Update">

[<a href="help/index.php">Help</a>]

</TD>
</TR>
</TABLE>

</FORM>

</CENTER>

<?php include_footer(); ?>

<?php

class tree_render_from_table {
  var $tree; // Note: if you remove this variable from a class - the recursion will fail on PHP 4

  function tree_render_from_table($tree) {
  	$this -> tree = $tree;
  }

  function display_tree($parent, $table_tree, $connection, $border) {
    $table_name = 'tax_'.$table_tree;
    $query = 'SELECT * FROM '.$table_name.' WHERE parent="'.$parent.'" ORDER BY rank';
    $result = $connection -> query($query);
    $layout = tax_get_layout();

    $number_of_rows_found = $result -> numRows();
    //echo "number_of_rows_found".$number_of_rows_found;
    for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
      $row = $result -> fetchRowAssoc();
      $id = $row['id'];
      $text = stripslashes($row['text']);

      $query_update = 'UPDATE '.$table_name.' SET rank = "'.(10 * ($idx + 1)).'" WHERE id ="'.$id.'"';
      $result_update = $connection -> query($query_update);

      $query2 = 'SELECT COUNT(id) FROM '.$table_name.' WHERE parent="'.$id.'"';
      $result2 = $connection -> query($query2);
      $row2 = $result2 -> fetchRowAssoc();
      $count = $row2['COUNT(id)'];
      $node_name = 'p_'.$parent.'_i_'.$idx;
      $checkbox_name = 'x_'.$id;

      $checkbox_set = isset($_POST[$checkbox_name]);

      if ($checkbox_set) {
        $checked = " CHECKED";
      } else {
        $checked = "";
      }

      if ($count > 0) {
        if ($idx == $number_of_rows_found - 1) {
          $this -> tree -> directory_last($node_name);
          //echo "END1";
        } else {
          //echo "END2";
          $this -> tree -> directory($node_name);
        }
        $name_edit = 'edit_'.$id;

        echo '<TABLE width="100%" cellpadding="0" cellspacing="0" align="center" border="0"><TR>';
        $this -> display_checkbox($id, $checkbox_name, $checked);
        $this -> display_directory_entry($id, $text, $table_tree);
        echo '</TR></TABLE>';

        $new_border = ($count > 1) && ($layout != 'f');

        $this -> display_tree($id, $table_tree, $connection, $new_border);
      } else {
        if ($idx == $number_of_rows_found - 1) {
          $this -> tree -> node_last($node_name);
        } else {
          $this -> tree -> node($node_name);
        }
        if ($border == true) {
          echo '<table cellspacing="1" cellpadding="1" width="100%" border="1" bgcolor="#F0F0F0"><TR><TD>';
        }
        echo '<TABLE cellpadding="0" cellspacing="0" border="0"><TR>';
        $this -> display_checkbox($id, $checkbox_name, $checked);
        $this -> display_node_entry($id, $text);
        echo '</TR></TABLE>';
        if ($border == true) {
          echo '</TD></TR></TABLE>';
        }
      }
    }
  }

  function display_directory_entry($id, $text, $taxonomy) {
    $editing = isset($_GET['x_'.$id]);
    if (isset($_GET['editing_fields'])) {
      $editing &= $_GET['editing_fields'] != "";
    } else {
      $editing = false;
    }
    $layout = tax_get_layout();
    echo '<TD width="8" valign="top"><div id="menu_'.$id.'"';
    if ($editing) {
      echo ' style="display=\'none\'"';
    }
    echo '><TABLE width="8"><TR>';

    $this -> display_menu($id);

    echo '</TR></TABLE></div></TD>'; // end of menu

    echo '<TD width="8" valign="top"><div id="tools_'.$id.'"';
    echo ' style="display=\'none\'"';
    echo '><TABLE width="16"><TR align="center">';

    $this -> display_nomenu($id);
    $this -> display_delete($id);
    $this -> display_edit($id);
    $this -> display_clone($id);
    $this -> display_birth($id);
    $this -> display_view($id, $taxonomy, $layout);

    echo '</TR></TABLE></div></TD>'; // end of tools

    echo '<TD valign="top" width="100%"><div id="text_'.$id.'"';

    if ($editing) {
      echo ' style="display=\'none\'"';
    }

    echo '><TABLE width="100%"><TR>';

    echo '<TD';

    if ($layout != "f") {
      echo ' align="center"';
    }
    echo '><STRONG>'.safe_text_to_html($text).'</STRONG></TD>';

    echo '</TR></TABLE></div></TD>'; // end of text

    echo '<TD valign="top" width="100%"><div id="save_'.$id.'"';

    if (!$editing) {
      echo ' style="display=\'none\'"';
    }

    echo '><TABLE align="center" width="100%"><TR>';
    echo '<TD width="100%"';

    if ($layout != "f") {
      echo ' align="center"';
    }

    echo '><input type="text" id="e_d_'.$id.'" name="t_'.$id.'" size="32" value="'.$text.'">&nbsp;</TD>';
    echo '<input type="hidden" name="h_d_'.$id.'" value="'.htmlentities($text).'">';
    echo '<TD valign="bottom"><a href="hide.php" onclick="hide_click_handler(\''.$id.'\'); return false;"><img src="graphics/hide.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a><BR>';
    echo '<a href="reset.php" onClick="return reset_click_handler(\''.$id.'\');"><img src="graphics/reset.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a><BR>';
    echo '<a href="update.php" onclick="return update_click_handler(\''.$id.'\');"><img src="graphics/update.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
    echo '</TR></TABLE></div></TD>';
  }

  function display_node_entry($id, $text) {
    $editing = isset($_GET['x_'.$id]);

    if (isset($_GET['editing_fields'])) {
      $editing &= $_GET['editing_fields'] != "";
    } else {
      $editing = false;
    }
    $layout = tax_get_layout();
    echo '<TD width="8" valign="top"><div id="menu_'.$id.'"';
    if ($editing) {
      echo ' style="display=\'none\'"';
    }
    echo '><TABLE width="8"><TR>';

    $this -> display_menu($id);

    echo '</TR></TABLE></div></TD>'; // end of menu

    echo '<TD width="8" valign="top"><div id="tools_'.$id.'"';
    echo ' style="display=\'none\'"';
    echo '><TABLE width="16"><TR align="center">';
    $this -> display_nomenu($id);
    $this -> display_delete($id);
    $this -> display_edit($id);
    $this -> display_clone($id);
    $this -> display_birth($id);
    echo '</TR></TABLE></div></TD>'; // end of tools

    echo '<TD valign="top" width="100%"><div id="text_'.$id.'"';

    if ($editing) {
      echo ' style="display=\'none\'"';
    }

    echo '><TABLE width="100%"><TR>';

    echo '<TD width="100%">'.safe_text_to_html($text).'</TD>';

    echo '</TR></TABLE></div></TD>'; // end of text

    echo '<TD valign="top" width="100%"><div id="save_'.$id.'"';
    if (!$editing) {
      echo ' style="display=\'none\'"';
    }
    echo '><TABLE><TR>';
    echo '<TD valign="top"><textarea id="e_d_'.$id.'" name="t_'.$id.'" rows="6" cols="50">'.$text.'</textarea></TD>';
    echo '<input type="hidden" id="h_d_'.$id.'" value="'.htmlentities($text).'">';
    echo '<TD valign="bottom"><a href="x" onclick="hide_click_handler(\''.$id.'\'); return false;"><img src="graphics/hide.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a><BR>';
    echo '<a href="x" onClick="reset_click_handler(\''.$id.'\'); return false;"><img src="graphics/reset.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmousedown="tax_press_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a><BR>';
    echo '<a href="x" onclick="update_click_handler(\''.$id.'\'); return false;"><img src="graphics/update.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
    echo '</TR></TABLE></div></TD>';
  }

  function display_menu($id) {
    echo '<TD valign="top" align="center" width="4"><a href="menu.php" onclick="return menu_click_handler(\''.$id.'\');"><img src="graphics/t_exp_all.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
  }

  function display_nomenu($id) {
    echo '<TD valign="top" align="center"><a href="nomenu.php" onclick="return nomenu_click_handler(\''.$id.'\');"><img src="graphics/t_col_all.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
  }

  function display_edit($id) {
    echo '<TD valign="top" align="center"><a href="edit.php" onclick="return edit_click_handler(\''.$id.'\');"><img src="graphics/edit.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
  }

  function display_delete($id) {
    echo '<TD valign="top" align="center"><a href="delete.php" onclick="return delete_1_click_handler(\''.$id.'\');"><img src="graphics/delete.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
  }

  function display_birth($id) {
    echo '<TD valign="top" align="center"><a href="birth.php" onclick="return birth_1_click_handler(\''.$id.'\');"><img src="graphics/birth.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
  }

  function display_clone($id) {
    echo '<TD valign="top" align="center"><a href="clone.php" onclick="return clone_1_click_handler(\''.$id.'\');"><img src="graphics/clone.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
  }

  function display_view($id, $taxonomy, $layout) {
    echo '<TD valign="top" align="center"><a href="index.php?name='.$taxonomy.'&parent='.$id.'&layout='.$layout.'"><img src="graphics/view.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a></TD>';
  }

  function display_checkbox($id, $checkbox_name, $checked) {
    echo '<TD valign="top" width="8"><input id="cb_'.$id.'"type="checkbox" name="'.$checkbox_name.'" '.$checked.'></TD>';
  }
}

function display_up($id, $taxonomy, $layout) {
  echo '<a href="index.php?name='.$taxonomy.'&parent='.$id.'&layout='.$layout.'"><img src="graphics/up.png" onmousedown="tax_press_element(this)" onmouseover="tax_select_element(this)" onmouseout="tax_deselect_element(this)" border="0"></a>';
}

function tax_get_layout() {
  $layout = ensure_string_from_get('layout');
  if ($layout == "") {
    $layout = ensure_string_from_post('layout');
    if ($layout == "") {
      $layout = "f";
    }
  }
  return $layout;
}

?>
