function toggle_all_checkboxes(element_all) {
  var html_form = element_all.form;
  for (i = 0; i < html_form.elements.length; i++) {
    form_element = html_form[i];
    if (form_element.type == 'checkbox') {
      form_element.checked = element_all.checked;
    }
  }
}

function check_all_checkboxes_form(html_form) {
  for (i = 0; i < html_form.elements.length; i++) {
    form_element = html_form[i];
    if (form_element.type == 'checkbox') {
      form_element.checked = true;
    }
  }
}

function uncheck_all_checkboxes_form(html_form) {
  for (i = 0; i < html_form.elements.length; i++) {
    form_element = html_form[i];
    if (form_element.type == 'checkbox') {
      form_element.checked = false;
    }
  }
}

function check_all_checkboxes() {
  check_all_checkboxes_form(document.form1);
}

function uncheck_all_checkboxes() {
  uncheck_all_checkboxes_form(document.form1);
}

function set_up_vars(button_pressed) {
  document.button_value = button_pressed.value;
  document.button_pressed = button_pressed;
}

function verifyAndSubmitForm() {
  var checkbox_count = 0;
  //var html_form = document.form1;
  var html_form = document.button_pressed.form;
  var total = html_form.elements.length;

  for (i = 0; i < total; i++) {
    form_element = html_form[i];
    if (form_element.type == 'checkbox') {
      if (form_element.checked) {
	      checkbox_count++;
      }
    }
  }

  if (document.button_value == 'All') {
    check_all_checkboxes();
    return false;
  }

  if (document.button_value == 'None') {
    uncheck_all_checkboxes();
    return false;
  }

  if (document.button_value == 'Edit') {
    //html_form.editing_fields.value = "true";
    html_form.action = "edit/index.php";
    return true;
  }

  if (document.button_value == 'Update') {
    html_form.action = "update/index.php";
    return true;
  }

  if (checkbox_count == 0) {
    alert("No selection made - please choose some objects first");
    return false;
  }

  if (document.button_value == 'Delete') {
    html_form.action = "delete/index.php";
  } else if (document.button_value == 'Prune') {
    html_form.action = "prune/index.php";
  } else if (document.button_value == 'Birth') {
    html_form.action = "birth/index.php";
  } else if (document.button_value == 'Clone') {
  	html_form.action = "clone/index.php";
  } else if (document.button_value == 'Up') {
  	html_form.action = "up/index.php";
  }

  if (document.button_value == 'Swap') {
    if (checkbox_count != 2) {
      alert("Exactly two nodes must be selected if you want to exchange their text");
      return false;
    }
    html_form.action = "swap/index.php";
  } else if (document.button_value == 'Graft') {
    if (checkbox_count != 2) {
      alert("Exactly two nodes must be selected if you want to prune and graft their branches onto one another");
      return false;
    }
    html_form.action = "graft/index.php";
  }

  //alert("html_form.action:" + html_form.action);

  return true;
}

function get_element_by_id(name) {
  if (!IE4) {
    return document.getElementById(name);
  } else {
    return document.all(name);
  }
}

function tax_press_element(element) {
  new_image = remove_any_existing_suffix(element.src);
  new_image = add_pressed_suffix(new_image);
  if (new_image != null) {
    element.src = new_image;
  }
}

function tax_deselect_element(element) {
  new_image = remove_any_existing_suffix(element.src);
  if (new_image != null) {
    element.src = new_image;
  }
}

function tax_select_element(element) {
  new_image = remove_any_existing_suffix(element.src);
  new_image = add_selection_suffix(new_image);
  if (new_image != null) {
    element.src = new_image;
  }
}

function remove_any_existing_suffix(str) {
  if (str == null) return "";

  idx = str.lastIndexOf(".");
  branch = str.substring(0,idx);

  sel_idx = branch.indexOf("_sel");
  if (sel_idx > -1) {
    len = branch.length;
    return branch.substring(0,len - 4) + ".png";
  }

  sel_idx = branch.indexOf("_pre");
  if (sel_idx > -1) {
    len = branch.length;
    return branch.substring(0,len - 4) + ".png";
  }

  return str;
}

function add_pressed_suffix(str) {
  idx = str.lastIndexOf(".");
  branch = str.substring(0,idx);

  return branch + "_pre.png";
}

function add_selection_suffix(str) {
  idx = str.lastIndexOf(".");
  branch = str.substring(0,idx);

  return branch + "_sel.png";
}

function menu_click_handler(node_name) {
  set_named_block_style("tools_" + node_name, "block");
  set_named_block_style("menu_" + node_name, "none");
  return false;
}

function nomenu_click_handler(node_name) {
  set_named_block_style("tools_" + node_name, "none");
  set_named_block_style("menu_" + node_name, "block");
  return false;
}

function edit_click_handler(node_name) {
  set_named_block_style("tools_" + node_name, "none");
  set_named_block_style("text_" + node_name, "none");
  set_named_block_style("save_" + node_name, "block");
  return false;
}

function hide_click_handler(node_name) {
  set_named_block_style("menu_" + node_name, "none");
  set_named_block_style("tools_" + node_name, "block");
  set_named_block_style("text_" + node_name, "block");
  set_named_block_style("save_" + node_name, "none");
  return false;
}

function update_click_handler(node_name) {
  html_form = document.form1;
  html_form.action = "update/index.php";
  html_form.submit();
  return false;
}

function prune_1_click_handler(node_name) {
  html_form = document.form1;
  uncheck_all_checkboxes(html_form);

  check_checkbox(node_name);

  html_form.action = "prune/index.php";
  html_form.submit();
  return false;
}

function birth_1_click_handler(node_name) {
  html_form = document.form1;
  uncheck_all_checkboxes(html_form);

  check_checkbox(node_name);

  html_form.action = "birth/index.php";
  html_form.submit();
  return false;
}

function clone_1_click_handler(node_name) {
  html_form = document.form1;
  uncheck_all_checkboxes(html_form);

  check_checkbox(node_name);

  html_form.action = "clone/index.php";
  html_form.submit();
  return false;
}

function delete_1_click_handler(node_name) {
  html_form = document.form1;
  uncheck_all_checkboxes(html_form);

  check_checkbox(node_name);

  html_form.action = "delete/index.php";
  html_form.submit();
  return false;
}

function check_checkbox(checkbox_name) {
  name_checkbox = "cb_" + checkbox_name;
  node_checkbox = get_element_by_id(name_checkbox);
  node_checkbox.checked = true;
}

function reset_click_handler(node_name) {
  name_hide_data = "h_d_" + node_name;
  name_edit_data = "e_d_" + node_name;

  node_hide_data = get_element_by_id(name_hide_data);
  node_edit_data = get_element_by_id(name_edit_data);

  node_edit_data.value = node_hide_data.value;
  return false;
}

function cancel_click_handler(node_name) {
  hide_click_handler(node_name);
  reset_click_handler(node_name);
  return false;
}

function set_named_block_style(block_name, type_name) {
  element_handle = get_element_by_id(block_name);

  element_handle.style.display = type_name;
}

