<?php
require_once ("paths.inc.php");
require_once ($path_root."lib/octoploid/php/basic_set_up.inc.php");
require_once ($path_lib_main_php."header.inc.php");
require_once ($path_lib_main_php."include_pear.inc.php");
require_once ($path_lib_main_php."config.inc.php");
require_once ($path_lib_main_php."utilities_get_and_post.inc.php");
require_once ($path_lib_main_php."safe_text_to_html.inc.php");

$script_name = $_SERVER['SCRIPT_NAME'];
$app_name = "Preview";
include_header_top($path_root, $path_app, $app_name);
title_image($path_root);
//render_app_title($app_name);

$connection = new DatabaseConnection($data_source_name);

$name = addslashes(ensure_string_from_get('name'));
$parent = addslashes(ensure_string_from_get('parent'));
$layout = addslashes(ensure_string_from_get('layout'));

if ($layout == "") {
  $layout = "1";
}

$query_string = $_SERVER['QUERY_STRING'];

if ($layout == 'f') {
  $tree_root = $path_root.'lib/tree/';
} else {
  $tree_root = $path_root.'lib/tree_nest/';
}

include_once($tree_root."php/tree_factory.class.php");
$tree_factory = new tree_factory($tree_root);

?>

<center>
<TABLE width="100%">
<TR>
<TD>

<?php

$tree = $tree_factory -> web_tree($layout);

$tree -> collapse_beyond_level(99);

if ($layout == 'f') {
  $tree -> collapse_all();
  $tree -> open_as_far_as(2);
  $tree -> expand_all();
}

$tree_render_from_table = new tree_render_from_table($tree);

$tree_render_from_table -> display_tree($parent, $name, $connection, ($layout != 'f'));

$tree -> node_end();

$tree_factory -> finalise();

?>

</TD>
</TR>
</TABLE>
</CENTER>

<?php include_footer(); ?>

<?php

class tree_render_from_table {
  var $tree; // Note: if you remove this variable from a class - the recursion will fail on PHP 4

  function tree_render_from_table($tree) {
  	$this -> tree = $tree;
  }

  function display_tree($parent, $table_tree, $connection, $border) {
    $table_name = 'tax_'.$table_tree;
    $query = 'SELECT * FROM '.$table_name.' WHERE parent="'.$parent.'" ORDER BY rank';
    $result = $connection -> query($query);
    $number_of_rows_found = $result -> numRows();
    //echo " #number_of_rows_found:".$number_of_rows_found;
    for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
      $row = $result -> fetchRowAssoc();
      $id = $row['id'];
      $text = stripslashes($row['text']);

      $query_update = 'UPDATE '.$table_name.' SET rank = "'.(10 * ($idx + 1)).'" WHERE id ="'.$id.'"';
      $result_update = $connection -> query($query_update);

      $query2 = 'SELECT COUNT(id) FROM '.$table_name.' WHERE parent="'.$id.'"';
      $result2 = $connection -> query($query2);
      $row2 = $result2 -> fetchRowAssoc();
      $count = $row2['COUNT(id)'];
      $node_name = 'p_'.$parent.'_i_'.$idx;

      $layout = ensure_string_from_get('layout');

      if ($count > 0) {
        if ($idx == ($number_of_rows_found - 1)) {
          $this -> tree -> directory_last($node_name);
          //echo "[directory_last:".$node_name.']<BR>';
        } else {
          $this -> tree -> directory($node_name);
          //echo "[directory:".$node_name.']<BR>';
        }
        echo '<TABLE cellpadding="0" cellspacing="0" width="100%"><TR><TD';
        if ($layout != "f") {
          echo ' align="center"';
        }

        echo ' valign="top" width="100%"><STRONG>';
        $this -> display_node_text($id, $text);
        echo '</STRONG></TD></TR></TABLE>';

        $this -> display_tree($id, $table_tree, $connection, ($count > 1) && ($layout != 'f'));
      } else {
        if ($idx == ($number_of_rows_found - 1)) {
          $this -> tree -> node_last($node_name);
          //echo "[node_last:".$node_name.']<BR>';
        } else {
          $this -> tree -> node($node_name);
          //echo "[node:".$node_name.']<BR>';
        }
        if ($border == true) {
          echo '<table cellspacing="1" cellpadding="1" width="100%" border="1" bgcolor="#F0F0F0"><TR><TD>';
        }
        echo '<TABLE cellpadding="0" width="100%" cellspacing="0"><TR><TD valign="top" width="100%">';
        $this -> display_node_text($id, $text);
        echo '</TD></TR></TABLE>';
        if ($border == true) {
          echo '</TD></TR></TABLE>';
        }
      }
    }
  }

  function display_node_text($id, $text) {
    echo safe_text_to_html($text);
  }

  function display_tree_leaves($parent, $table_name, $connection) {
    $query = "SELECT * FROM ".$table_name." WHERE parent='$parent' ORDER BY rank";
    $result = $connection -> query($query);

    echo '<OL>\n';
    $number_of_rows_found = db_num_rows($result);
    for ($idx = 0; $idx < $number_of_rows_found; $idx++) {
      $row = $result -> fetchRowAssoc();
      $id = $row['id'];
      $text = $row['text'];

      $query2 = 'SELECT COUNT(id) FROM '.$table_name.' WHERE parent="$id"';
      $result2 = $connection -> query($query2);
      $row = $result2 -> fetchRowAssoc();
      $count = $row['COUNT(id)'];

      echo '<LI>'.$text.'\n';

      if ($count > 0) {
        display_tree_leaves($id, $table_name, $connection);
      }
    }

    echo '</OL>\n';
  }
}
?>
